/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETCOMPONENT_ADVANCEDSERVOMOTOR_H_
#define _PHIDGETCOMPONENT_ADVANCEDSERVOMOTOR_H_

#include "PhidgetPlugin.h"

// methods
double phidgetCompAdvancedServoMotor_GetVelocityLimit(PhidgetId id, int iIndex);
BOOL phidgetCompAdvancedServoMotor_SetVelocityLimit(PhidgetId id, int iIndex, double dLimit);
double phidgetCompAdvancedServoMotor_GetVelocity(PhidgetId id, int iIndex);
double phidgetCompAdvancedServoMotor_GetVelocityMin(PhidgetId id, int iIndex);
double phidgetCompAdvancedServoMotor_GetVelocityMax(PhidgetId id, int iIndex);
BOOL phidgetCompAdvancedServoMotor_SetPositionMax(PhidgetId id, int iIndex, double dPosition);
BOOL phidgetCompAdvancedServoMotor_SetPositionMin(PhidgetId id, int iIndex, double dPosition);
double phidgetCompAdvancedServoMotor_GetAcceleration(PhidgetId id, int iIndex);
BOOL phidgetCompAdvancedServoMotor_SetAcceleration(PhidgetId id, int iIndex, double dAcceleration);
double phidgetCompAdvancedServoMotor_GetAccelerationMin(PhidgetId id, int iIndex);
double phidgetCompAdvancedServoMotor_GetAccelerationMax(PhidgetId id, int iIndex);
double phidgetCompAdvancedServoMotor_GetCurrent(PhidgetId id, int iIndex);
BOOL phidgetCompAdvancedServoMotor_IsSpeedRampingOn(PhidgetId id, int iIndex);
BOOL phidgetCompAdvancedServoMotor_SetSpeedRampingOn(PhidgetId id, int iIndex, BOOL bState);
BOOL phidgetCompAdvancedServoMotor_IsStopped (PhidgetId id, int iIndex); //BOOL bStopped
BOOL phidgetCompAdvancedServoMotor_SetSemaphoreIndex_CurrentChange(PhidgetId id, int iSemaphoreIndex);
BOOL phidgetCompAdvancedServoMotor_SetSemaphoreIndex_VelocityChange(PhidgetId id, int iSemaphoreIndex);

#endif // _PHIDGETCOMPONENT_ADVANCEDSERVOMOTOR_H_
