/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETACCELEROMETER_H_
#define _PHIDGETACCELEROMETER_H_

typedef struct _PhidgetAccel PhidgetAccel;

#include "PhidgetPlugin.h"

//
// Special Phidget-struct for an Accelerometer. Additionally contains semaphores
// concerning the change of an axis
//

struct _PhidgetAccel {
	CPhidgetAccelerometerHandle handle;	// handle provided by phidget21 library upon creation
	PhidgetId id;						// timestamp of object creation to provide unique identifier
	CPhidget_DeviceClass deviceClass;	// the Phidget's type
	Phidget* pNextLink;					// pointer to next Phidget in the Plugin's global Phidgets list
	int	iSemaphoreAttach;				// semaphore index for Accelerometer attachment
	int iSemaphoreDetach;				// semaphore index for Accelerometer detachment
	int iSemaphoreError;				// semaphore index for errors in Phidgets
	int	iSemaphoreAccelerationChange;	// semaphore index for change of position of an axis
};

// methods
sqInt phidgetAccel_Create();
void phidgetAccel_ResetSemaphores(PhidgetAccel *pPhidget);
BOOL phidgetAccel_Close(PhidgetAccel *pPhidget);
BOOL phidgetAccel_Open(PhidgetAccel *pPhidget);

#endif //_PHIDGETACCELEROMETER_H_
