/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETTEXTLCD_H_
#define _PHIDGETTEXTLCD_H_

typedef struct _PhidgetTextLCD PhidgetTextLCD;

#include "PhidgetPlugin.h"

//
// Special Phidget-struct for an TextLCD Phidget. 
//

struct _PhidgetTextLCD {
	CPhidgetTextLCDHandle handle;		// handle provided by phidget21 library upon creation
	PhidgetId id;						// timestamp of object creation to provide unique identifier
	CPhidget_DeviceClass deviceClass;	// the Phidget's type
	Phidget* pNextLink;					// pointer to next Phidget in the Plugin's global Phidgets list
	int iSemaphoreAttach;				// semaphore index for TextLCD attachment
	int iSemaphoreDetach;				// semaphore index for TEXTLCD detachment
	int iSemaphoreError;				// semaphore index for errors in Phidgets
};

// methods
PhidgetId phidgetTextLCD_Create();
void phidgetTextLCD_ResetSemaphores(PhidgetTextLCD *pPhidget);
BOOL phidgetTextLCD_Open(PhidgetTextLCD *pPhidget);
BOOL phidgetTextLCD_Close(PhidgetTextLCD *pPhidget);

#endif // _PHIDGETTEXTLCD_H_
